/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

import java.awt.*;
import java.awt.event.*;
import java.io.BufferedReader;
import java.io.StringReader;
import java.util.Vector;
import net.hoopajoo.swingx.*;

public class CheeseMapSearch extends JEscDialog implements ActionListener, ListSelectionListener {
	JTextField distance, search;
	JTable search_results;
	DefaultListModel list_data = new DefaultListModel();
	MyTableModel result_data = new MyTableModel();
	JCheckBox search_name, search_desc, search_notes;
	JTabbedPane tp;
	
	CheeseMapSearch( Frame owner ) {
		super( owner );
		final JDialog dialog = this;
		setTitle( "Search" );
		
		JPanel panel;
		Container mainpane = getContentPane();
		mainpane.setLayout( new BorderLayout() );
		
		JPanel cpane = new JPanel();
		cpane.setLayout( new BorderLayout() );
		
		JButton button;
		tp = new JTabbedPane();
		cpane.add( tp, BorderLayout.CENTER );
		
		panel = new JPanel( new BorderLayout() );
		tp.add( "Name/Desc", panel );
		panel.add( new JLabel( "Search: " ), BorderLayout.WEST );
		panel.add( search = new JTextField( 50 ), BorderLayout.CENTER );
		search.addActionListener( this );
		search.setActionCommand( "search" );
		panel.add( panel = new JPanel(), BorderLayout.SOUTH );
		panel.add( search_name = new JCheckBox( "Name" ) );
		panel.add( search_desc = new JCheckBox( "Description" ) );
		panel.add( search_notes = new JCheckBox( "Notes" ) );
		search_name.setSelected( true );
		
		// TODO: Actually implement advanced search and remove those lines
		search_name.setEnabled( false );
		search_desc.setEnabled( false );
		search_notes.setEnabled( false );
		
		panel = new JPanel();
		panel.add( new JLabel( "Sorry, this feature is not implemented yet!" ) );
		tp.add( "Overlays", panel );
		
		panel = new JPanel();
		panel.add( new JLabel( "Sorry, this feature is not implemented yet!" ) );
		tp.add( "Exits", panel );
		
		panel = new JPanel();
		panel.add( new JLabel( "Sorry, this feature is not implemented yet!" ) );
		tp.add( "Misc", panel );
		
		panel = new JPanel();
		panel.setLayout( new GridBagLayout() );
		GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridy = GridBagConstraints.RELATIVE;
        c.gridx = 0;
        
		panel.add( button = new JButton( "Find" ), c );
		button.setActionCommand( "search" );
		button.addActionListener( this );
		// panel.add( button = new JButton( "Stop" ), c );
		panel.add( button = new JButton( "Close" ), c );
		button.addActionListener( new ActionListener() {
		    public void actionPerformed( ActionEvent e ) {
		        dialog.dispatchEvent( new WindowEvent(
                        dialog, WindowEvent.WINDOW_CLOSING ) );
		    }
		} );
		cpane.add( panel, BorderLayout.EAST );
		mainpane.add( cpane, BorderLayout.NORTH );
		
        TableSorter sorter = new TableSorter( result_data );
		search_results = new JTable( sorter );
        search_results.setShowGrid( true );
        sorter.setTableHeader(search_results.getTableHeader());
        search_results.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        search_results.getSelectionModel().addListSelectionListener( this );
        search_results.setPreferredScrollableViewportSize( new Dimension( 500, 200 ) );
		mainpane.add( new JScrollPane( search_results ), BorderLayout.CENTER );
		
		// This resets search options and sets focus when dialog is opened
		dialog.addComponentListener( new ComponentAdapter() {
		    public void componentShown(ComponentEvent e) {
		        tp.setSelectedIndex( 0 );
		        search.requestFocusInWindow();
		    }
		} );

		pack();
	}
	
	public void actionPerformed( ActionEvent e ) {
		CheeseLab.dmesg( 2, "Move" );
		
		String cmd = e.getActionCommand();
		
		if( cmd.equals( "search" ) ) {
		    // We are inside a like clause thus we need to add %-s
			CheeseMap.send_tx( 1, "search", "%" + search.getText() + "%" );
		}
	}

	public void valueChanged( ListSelectionEvent e ) {
		if( e.getValueIsAdjusting() == false ) {
		    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
	        if ( !lsm.isSelectionEmpty() ) {
	            int row = lsm.getMinSelectionIndex();
	            CheeseLab.dmesg( 3, "Search result row selected: " + row );
	            int roomid = 0;
	            
	            roomid = Integer.parseInt( 
	                    (String)result_data.getValueAt( row, 0 ) );
	            CheeseLab.dmesg( 3, "Got " + roomid + 
	                    			" from " + row + ". row" );
	            
	            if( roomid != 0 ) {
					CheeseMap.set_edit_room( roomid, false );
				}
	        }
		}
	}
	
	public void set_search_results( byte[] b ) {
	    // TODO: This could be configurable
	    int [] colwidths = { 60, 500 };
	    String [] colnames = { "No.", "Name" };
	    int oldcols = result_data.cols;
	    
		CheeseLab.dmesg( 2, "Accepting search results" );
		list_data.clear();
		result_data.clear();
		
		String s = new String( b );
		BufferedReader in = new BufferedReader( new StringReader( s ) );
		String line;
		try{
			while( (line = in.readLine()) != null ) {
			    CheeseLab.dmesg( 5, "Got: " + line );
				String[] values = line.split( "," );
				if( result_data.cols < values.length )
				    result_data.cols = values.length;
				result_data.data.add( values );
			}
			result_data.columnNames = colnames;
			/* Check if number of columns changed, making this distinction
			 * is good, because table cells will not resize if there was no
			 * change and this improves the user experience.
			 */
			if( oldcols == result_data.cols ) {
			    result_data.fireTableDataChanged();
			}else{
			    result_data.fireTableStructureChanged();
			    for (int i = 0; i < colwidths.length; i++) {
				    search_results.getColumnModel().getColumn(i).
				    					setPreferredWidth( colwidths[i] );
			    }
			}  
			
			search_results.repaint();
		}catch( Exception e ){
		}
	}
	
	/**
	 * This class implements the data model used by search results table.
	 * The implementation uses a Vector to hold String arrays of table data.
	 * Arrays can be of arbitary size, the model returns empty strings for
	 * elements that do not exist. 
	 * @author anttix
	 */
	private class MyTableModel extends AbstractTableModel {
		    public int cols = 0;
		    public Vector data = new Vector();
		    public String [] columnNames;
		    
		    public int getColumnCount() {
		        return cols;
		    }
		    public int getRowCount() {
		        return data.size();
		    }
		    public String getColumnName(int col) {
		        if ( col >= columnNames.length )
		            return "";
		        else
		            return columnNames[col];
		    }
		    public Object getValueAt(int row, int col) {
		        String [] r = (String[])data.elementAt( row );
		        if( col >= r.length )
		            return "";
		        else
		            return r[col];
		    }
		    public void clear() {
		        cols = 0;
		        data.clear();
		        columnNames = new String[0];
		    }
		}
}
